<template>
    <div class="d-grid gap-2 my-3">
        <button class="btn btn-misc" type="button" v-if="!subscriberFinal" @click="subscribeTo('subscribe', 'final')">
            <i class="fa fa-check fa-fw"></i>
            {{ $t('subscribe_final') }}
        </button>
        <button class="btn btn-misc" type="button" v-if="subscriberFinal" @click="subscribeTo('unsubscribe', 'final')">
            <i class="fa fa-times fa-fw"></i>
            {{ $t('unsubscribe_final') }}
        </button>
        <button class="btn btn-misc" type="button" v-if="!subscriberStep" @click="subscribeTo('subscribe', 'step')">
            <i class="fa fa-check fa-fw"></i>
            {{ $t('subscribe_all_steps') }}
        </button>
        <button class="btn btn-misc" type="button" v-if="subscriberStep" @click="subscribeTo('unsubscribe', 'step')">
            <i class="fa fa-times fa-fw"></i>
            {{ $t('unsubscribe_all_steps') }}
        </button>
    </div>
</template>

<script>
import {makeFetch} from 'ChillMainAssets/lib/api/apiMethods.ts';

export default {
    name: "EntityWorkflowVueSubscriber",
    i18n: {
       messages: {
          fr: {
             subscribe_final: "Recevoir une notification à l'étape finale",
             unsubscribe_final: "Ne plus recevoir de notification à l'étape finale",
             subscribe_all_steps: "Recevoir une notification à chaque étape du suivi",
             unsubscribe_all_steps: "Ne plus recevoir de notification à chaque étape du suivi",
          }
       }
    },
    props: {
        entityWorkflowId: {
            type: Number,
            required: true,
        },
        subscriberStep: {
            type: Boolean,
            required: true,
        },
        subscriberFinal: {
            type: Boolean,
            required: true,
        },
    },
    emits: ['subscriptionUpdated'],
    methods: {
        subscribeTo(step, to) {
            let params = new URLSearchParams();
            params.set('subscribe', to);

            const url = `/api/1.0/main/workflow/${this.entityWorkflowId}/${step}?` + params.toString();

            makeFetch('POST', url).then(response => {
                this.$emit('subscriptionUpdated', response);
            });
        }
    },
}
/*
*   ALTERNATIVES
*
    <div class="form-check form-switch">
        <input class="form-check-input" type="checkbox" role="switch" id="laststep">
        <label class="form-check-label" for="laststep">{{ $t('subscribe_final') }}</label>
    </div>
    <div class="form-check form-switch">
        <input class="form-check-input" type="checkbox" role="switch" id="allsteps">
        <label class="form-check-label" for="allsteps">{{ $t('subscribe_all_steps') }}</label>
    </div>

    <div class="list-group my-3">
        <label class="list-group-item">
            <input class="form-check-input me-1" type="checkbox" value="">
            {{ $t('subscribe_final') }}
        </label>
        <label class="list-group-item">
            <input class="form-check-input me-1" type="checkbox" value="">
            {{ $t('subscribe_all_steps') }}
        </label>
    </div>

    <div class="btn-group-vertical my-3" role="group">
        <button type="button" class="btn btn-outline-primary">
            <i class="fa fa-check fa-fw"></i>
            {{ $t('subscribe_final') }}
        </button>
        <button type="button" class="btn btn-outline-primary">
            <i class="fa fa-check fa-fw"></i>
            {{ $t('subscribe_all_steps') }}
        </button>
    </div>
*/
</script>

<style scoped></style>
